﻿var index=0;
var timer=null;
var http=null;
var gLastUpdate=null;
var snippet=""
var htmlDetailsView=null;
var query_url="http://video.google.com/videofeed?type=search&q=user%3A%22Google+engEDU%22&so=1&num=20&output=rss"
var details_state;

var imageArray = new Array();
var linkArray = new Array();
var titleArray = new Array();
var descArray = new Array();
var swfArray = new Array();
var pubArray = new Array();

function replaceAll(oldStr,findStr,repStr) { //To replace characters
  var srchNdx = 0;  
  var newStr = "";  
  while (oldStr.indexOf(findStr,srchNdx) != -1) {
    newStr += oldStr.substring(srchNdx,oldStr.indexOf(findStr,srchNdx));
    newStr += repStr;
    srchNdx = (oldStr.indexOf(findStr,srchNdx) + findStr.length);            
  }
  newStr += oldStr.substring(srchNdx,oldStr.length);
  return newStr;
}

function retry()
{
  retrynow.visible=false;
  view_onOpen();
}

function m_over()
{
  status_label.innerText=strTalk;
  status_label.visible=true;
}

function m_out()
{
  status_label.visible=false;
}

function view_onOpen()
{
  shadow.visible=false;
  slide.visible=false;
  reflex1.visible=false;
  prev.visible=false;
  next.visible=false;
  status_label.visible=true;
  status_label.innertext=strLoading;
  videoTitle.visible=false;
  retrynow.visible=false;
  OnTimer(query_url);
}

function OnTimer(url) {
  // set timer to do the query once every 30 minutes
  view.setTimeout("OnTimer(query_url)", 
    30 * 60 * 1000 + Math.random() * 10000 - 5000);

  http = new XMLHttpRequest();
  http.onreadystatechange = afterResponse;
  http.open("GET", url, true);
  if (gLastUpdate) {
    debug.trace("last update: " + gLastUpdate);
    http.setRequestHeader("If-modified-since", gLastUpdate);
  }
  http.send();

  function afterResponse() {
    if (http.readyState == 4) {
      if (http.status != 200) {
        shadow.visible=false;
	slide.visible=false;
	reflex1.visible=false;
	prev.visible=false;
	next.visible=false;
	status_label.visible=true;
	videoTitle.visible=false;
	status_label.innertext=strnetConn;
        retrynow.visible=true;
        return;
      }

      var doc = new DOMDocument();
      
      doc.loadXML(http.responseText);
      
      Tags = doc.getElementsByTagName("item");
      
      if (Tags == null || Tags.length <= 0) {
     //   show_error_fetching_videos_msg();
        return;
      }
      
      try {
        for(i = 0; i < Tags.length; i++) {
          var title ="";
          var link ="";
          var desc ="";
          var imag ="";
          var pub ="";
          
          // for each item
          for (var node = Tags[i].firstChild; node != null; node = node.nextSibling) {
            if (node.nodeName == "title"){
              title = node.firstChild.nodeValue;}
            if (node.nodeName == "link"){
              link = node.firstChild.nodeValue;}
            if (node.nodeName == "description"){
              desc = node.firstChild.nodeValue;
              }
          // look for media:group
		  if(node.prefix == "media" && node.baseName == "group")
			{
				// Go through all types of media returned
				// and look for media:thumbnail
				var tempNode = node;
				for (var mgChild = tempNode.firstChild; mgChild != null; mgChild = mgChild.nextSibling)
	  	  		{
	  	  			// media:thumbnail found
					if(mgChild.prefix == "media" && mgChild.baseName == "thumbnail")
					{
  						var oNamedNodeMap = mgChild.attributes;
   						imag = oNamedNodeMap.getNamedItem("url").value;
					}
				}
				
			}
	
        
            if (node.nodeName == "enclosure"){
              swf = node.attributes.getNamedItem("url").value;
              swf = replaceAll(swf,".swf","");
            }
            if (node.nodeName == "pubDate"){
              pub = node.firstChild.nodeValue;
            }
          }
            imageArray.push(imag);
            titleArray.push(title);
            linkArray.push(link);
            descArray.push(desc);
            swfArray.push(swf);
            pubArray.push(pub);
        }
      } catch(e) {
       shadow.visible=false;
	slide.visible=false;
	reflex1.visible=false;
	prev.visible=false;
	next.visible=false;
	status_label.visible=true;
        videoTitle.visible=false;
	status_label.innertext=strnetConn;
        retrynow.visible=true;
        return;
      }
      
      delete http;
      delete doc;
      
   //   loading_msg.visible = false;
   //   error_fetching_videos_msg.visible = false;

      drawItem();
      cacheImages();      
    }
  }
}

//click event for the previous button. Sets the active index to index-1 if exists
function prevOnClick() {
  index--;
  if (index < 0)
    index = imageArray.length - 1;
  drawItem();
}

//click event for the next button. Sets the active index to index+1 if exists
function nextOnClick() {
  index = (index + 1) % imageArray.length;
  drawItem();
}

function drawItem() {

  shadow.visible=true;
  slide.visible=true;
  reflex1.visible=true;
  prev.visible=true;
  next.visible=true;
  status_label.visible=false;
  videoTitle.visible=true;
  retrynow.visible=false;

  var http = new XMLHttpRequest();
  http.onreadystatechange = afterVideoStream;  
  http.open("GET",imageArray[index], true);
  http.send();

  function afterVideoStream() {
    if (http.readyState == 4) {
      if (http.status != 200)  return;
      videoTitle.innerText = titleArray[index];
      var currentY = new Date();
      pubD.tooltip=pubArray[index];
      pubD.innerText = pubArray[index].substring(0, pubArray[index].indexOf(" "+currentY.getYear()));
      slide.image = http.responseStream;
      slide.tooltip = titleArray[index];
      snippet = "<div id=\"container\" style=\"position:absolute; width=\"500\"; height=\"400\" top:0; left:0; border:1px solid white; z-index:2;\">" 
        + descArray[index]
        + "</div>";
    } 
    if(http != null) delete http;
  }
}

function cacheImages() {
  for(var i=0;i<imageArray.length;i++) {
    var http = new XMLHttpRequest();
    http.onreadystatechange = afterVideoStream;  
    http.open("GET",imageArray[i],true);
    http.send();

    function afterVideoStream() { 
      if (http.readyState == 4) {
        if (http.status != 200)
          return;
      } 
      if(http != null)
        delete http;
    }
  }
}

function onSlideClick() {
  if(details_state) {
    plugin.CloseDetailsView();
    return;
  } 
  // no data shown?
  if (slide.image == null)
    return;

  var detailsHTML = "<html><head><script>window.external.window = window;</script><style type=\"text/css\"> body{font-family:arial,sans-serif; font-size: 10px; margin-left: 5px; margin-top: 5px; margin-right: 5px; margin-bottom: 5px;}</style></head><body bgcolor=\"#ffffff\" text=\"000000\" link=\#FFFF00\ vlink=\#FFCC99\ alink=\#FFFF00\>";
  detailsHTML += snippet;
  detailsHTML += "<br /><br /></body></html>";

  if (htmlDetailsView != null)
    pluginHelper.closeDetailsView();

  htmlDetailsView = new DetailsView();
  htmlDetailsView.html_content = true;
  htmlDetailsView.setContent("", undefined, detailsHTML, false, 0);
  htmlDetailsView.external = {};

  // Show the details view
  pluginHelper.showDetailsView(htmlDetailsView, titleArray[index], 
    gddDetailsViewFlagToolbarOpen, onDetailsViewFeedback);
  details_state = 1 ;
}

function onDetailsViewFeedback(detailsViewFlags) {
  // Remove the movie from DOM to make it stop playing
  var window = htmlDetailsView.external.window;
  var movie = window.document.getElementById("movie");
  if (movie != null)
    movie.parentNode.removeChild(movie);

  if (detailsViewFlags == gddDetailsViewFlagNone) {
    // User closed the details view
    details_state = 0; 
  } else if (detailsViewFlags == gddDetailsViewFlagToolbarOpen) {
    // User clicked on the title of the details view
    var winShell = new ActiveXObject("Shell.Application"); 
    winShell.ShellExecute(linkArray[index]); 
    winShell = null;
  }

  htmlDetailsView=null;
  CollectGarbage();
}

function view_onClose() {
  if(htmlDetailsView != null) {
    htmlDetailsView=null;
    CollectGarbage();
  }
}

